import java.awt.*;
import java.awt.event.*;
import simphy.*;

public class RunPendulum extends Frame implements Runnable, Simulation {
    WorldGraphics wg;
    ChaoticPendulum p;
    boolean running = false;
    Thread runner;
	public double dt = 0.001;
	public double t = 0;
	ControlFrame cf;
	int steps = 100;
	double r = 0.05; // bob radius

    
	public static void main(String[] args) {
		RunPendulum ps = new RunPendulum();   // set up window for application
	}
	
	public RunPendulum() {     // constructor
		setVisible(false);
	    p = new ChaoticPendulum(0.0, 0.2);
        String lString[] = {"Theta (radians)", "Omega", "gamma", "Driver A","Driver Freq.","dt","steps"};
        String bString[] = {"start", "stop"};
        cf = new  ControlFrame(this,lString,bString);
        wg = new WorldGraphics("Chaotic Pendulum",-1.5,1.5,-1.5,1.5);
        wg.setToScreen(false);
	    start();

	}

                
    public void start() {
     runner = new Thread(this);
     runner.start();
    }

    public void stop() {
     runner.stop();
    }

    public void run() {
     while(true) {
         try {Thread.sleep(5);}  // delay 5 msec between updates
         catch (InterruptedException e){};
         if(running) calculateTrajectory();
      }
    }

	public void calculateTrajectory() {
            wg.clearRect(p.getX()-r,p.getY()-r,2*r,2*r);          
		    wg.clearLine(p.getX(),p.getY(),p.getXC(),p.getYC());
			for (int i = 0;i < steps;i++) {
			   p.step(dt, t);
			   t += dt;
			}
		    wg.fillOval(p.getX()-r, p.getY()-r,2*r,2*r);
		    wg.drawLine(p.getX(),p.getY(),p.getXC(),p.getYC());
            wg.drawBuffer();
	}
	
	
	    public void buttonAction(int k) {
	       switch(k) {
	         case 0: running = true;break;
	         case 1: running = false;break;
	       }
	    }
        
        public void textAction(int k, double x){
	       switch(k) {
	         case 0: wg.clearRect(p.getX()-r,p.getY()-r,2*r,2*r);          
		             wg.clearLine(p.getX(),p.getY(),p.getXC(),p.getYC());
		             p.setTheta(x); 
                     break;
	         case 1: p.setOmega(x);break;
	         case 2: p.setGamma(x);break;
	         case 3: p.setA(x);break;
	         case 4: p.setOmegaD(x);break;
	         case 5: dt = x;break;
	         case 6: steps = (int)x;break;
	       }
	    }
        
        
        public void menuAction(int k){;}
        
        public void dialogAction(int k, double x){;}

}